package com.qunzhixinxi.hnqz.admin.api.constant;

import com.baomidou.mybatisplus.annotation.EnumValue;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * Upms状态枚举
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-08-15 15:24
 */
public class UpmsState {

    /**
     * 业务提醒已读状态
     *
     * @author lixuesong
     * @date 2023/10/25
     */
    @Getter
    @AllArgsConstructor
    public enum BizReminderReadStatus {

        READ("READ", "已读"),
        UNREAD("UNREAD", "未读");

        @EnumValue
        private final String status;
        private final String description;
    }

    /**
     * 积分包结算财务复核状态
     *
     * @author lixuesong
     * @date 2024/01/05
     */
    @Getter
    @AllArgsConstructor
    public enum SettleFinancialReviewStatus {
        AUTO("AUTO", "自动"),
        TO_BE_REVIEWED("TO_BE_REVIEWED", "待复核"),
        PASSED("PASSED", "通过"),
        REJECTED("REJECTED", "拒绝");

        @EnumValue
        private final String status;
        private final String description;
    }


    /**
     * 执行计划类型
     *
     * @author ImplementPlanType
     * @version 1.0.0
     * @date 2024/05/19 11:22
     */
    @Getter
    @AllArgsConstructor
    public enum ImplementPlanState {

        INIT("INIT", "新建"),
        IN_PROGRESS("IN_PROGRESS", "执行中"),
        REJECTED("REJECTED", "拒绝"),
        PASSED("PASSED", "通过"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }

    /**
     * 执行计划类型
     *
     * @author ImplementPlanType
     * @version 1.0.0
     * @date 2024/05/19 11:22
     */
    @Getter
    @AllArgsConstructor
    public enum ImplPlanDetailsState {

        INIT("INIT", "新建"),
        CKT1("CKT1", "待审核1"),
        CKT2("CKT2", "待审核2"),
        REJECTED("REJECTED", "拒绝"),
        PASSED("PASSED", "通过"),
        ;

        @EnumValue
        private final String state;
        private final String desc;
    }
}
