package com.qunzhixinxi.hnqz.admin.controller;

import com.qunzhixinxi.hnqz.admin.manager.SysStatisticManager;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * 统计前端控制器
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2024/05/26 15:21
 */
@Slf4j
@RestController
@AllArgsConstructor
public class SysStatisticController {

    private final SysStatisticManager statisticManager;


    @GetMapping(value = "/stat/pkg")
    public R<Map<String, Object>> getPkgStat() {
        HnqzUser operator = SecurityUtils.getUser();
        Map<String, Object> res = statisticManager.getPkgStat(operator);
        return R.ok(res);
    }


    @GetMapping(value = "/stat/task")
    public R<Map<String, Object>> getTaskStat() {

        HnqzUser operator = SecurityUtils.getUser();
        Map<String, Object> res = statisticManager.getTaskStat(operator);
        return R.ok(res);
    }


}
