package com.qunzhixinxi.hnqz.report.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.google.common.base.Joiner;
import com.google.common.base.Splitter;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.report.config.UpmsConfig;
import com.qunzhixinxi.hnqz.admin.api.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.admin.api.entity.WmReport;
import com.qunzhixinxi.hnqz.admin.api.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskContent;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskContentConfig;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmUserSign;
import com.qunzhixinxi.hnqz.admin.api.entity.WmUserSignDetail;
import com.qunzhixinxi.hnqz.admin.api.entity.XlsTask;
import com.qunzhixinxi.hnqz.report.service.ReportExportForGuangshengtangService;
import com.qunzhixinxi.hnqz.report.service.ReportExportService;
import com.qunzhixinxi.hnqz.report.service.SysDeptService;
import com.qunzhixinxi.hnqz.report.service.SysFileService;
import com.qunzhixinxi.hnqz.report.service.SysUserService;
import com.qunzhixinxi.hnqz.report.service.WmDaDrugEntDrugtableService;
import com.qunzhixinxi.hnqz.report.service.WmDaDrugEntService;
import com.qunzhixinxi.hnqz.report.service.WmScorePackageService;
import com.qunzhixinxi.hnqz.report.service.WmScorePackageStatusService;
import com.qunzhixinxi.hnqz.report.service.WmTaskContentConfigService;
import com.qunzhixinxi.hnqz.report.service.WmTaskContentService;
import com.qunzhixinxi.hnqz.report.service.WmTaskService;
import com.qunzhixinxi.hnqz.report.service.WmTaskTypeService;
import com.qunzhixinxi.hnqz.report.service.WmUserSignService;
import com.qunzhixinxi.hnqz.report.util.ExportReport;
import com.qunzhixinxi.hnqz.report.util.Html2ImageByJsWrapper;
import com.qunzhixinxi.hnqz.common.core.util.R;
import lombok.AllArgsConstructor;
import org.apache.commons.io.IOUtils;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;


/**
 * <p>
 * 报告管理 服务实现类
 * </p>
 *
 * @author hnqz
 * @since 2018-01-20
 */
@Service("ReportExportForGuangshengtangServiceImpl")
@AllArgsConstructor
public class ReportExportForGuangshengtangServiceImpl implements ReportExportService {

    private final WmTaskService wmTaskService;
    private final WmScorePackageService wmScorePackageService;
    private final UpmsConfig upmsConfig;
    private final SysFileService sysFileService;
    private final WmDaDrugEntService wmDaDrugEntService;
    private final WmTaskTypeService wmTaskTypeService;
    private final SysUserService sysUserService;
    private final SysDeptService sysDeptService;
    private final WmTaskContentService wmTaskContentService;
    private final WmTaskContentConfigService wmTaskContentConfigService;
    private final WmDaDrugEntDrugtableService wmDaDrugEntDrugtableService;
    private final WmUserSignService wmUserSignService;
    private final WmScorePackageStatusService wmScorePackageStatusService;
    private final ReportExportService reportExportService;

    /**
     * 个人承接按积分制-单独用于广生堂
     *
     * @param wmTask
     * @param username
     * @return
     * @throws IOException
     */
    @Override
    public R newExportZb(WmTask wmTask, String username) throws IOException {
        String packageId = wmTask.getScorePackageDrugId();
        if (null == packageId) {
            return R.failed("积分包ID不能为空");
        }
        LambdaQueryWrapper<WmTask> queryWrapper = new LambdaQueryWrapper();
        queryWrapper.in(WmTask::getScorePackageId, Arrays.asList(packageId.split(",")));
        queryWrapper.eq(WmTask::getTaskStatus, "3");
        queryWrapper.eq(WmTask::getDelFlag, "0");
        queryWrapper.eq(WmTask::getEnableFlag, "0");
        queryWrapper.eq(WmTask::getRealFlag, "0");
        List<WmTask> taskList = wmTaskService.list(queryWrapper);
        if (taskList.isEmpty()) {
            return R.failed("未查询到审核通过的任务");
        }
        String ids = taskList.stream().map(WmTask::getId).collect(Collectors.joining(","));
        wmTask.setScorePackageId(packageId);
        wmTask.setId(ids);
        return exportZbForGuangshengtang(wmTask, username);
    }

    /**
     * 个人报告导出--众包代表业绩报告-单独用于广生堂
     *
     * @param wmTask
     * @return
     * @throws IOException
     */
    private R exportZbForGuangshengtang(WmTask wmTask, String username) throws IOException {

        WmTask wmTaskparam = wmTask;
        String packageId = wmTask.getScorePackageId();  // 获取积分包ID
        if (null == packageId) {
            packageId = wmTask.getScorePackageDrugId();
        }

        if (null == packageId) {
            return R.failed("积分包ID不能为空");
        }

        WmScorePackage wmScorePackage1 = wmScorePackageService.getById(packageId);

        Map<String, Object> excelMap = exportZbCommonForGuangshengtang(wmTask);
        if (null == excelMap) {
            return R.failed("未查询到审核通过的任务");
        }

        List<Map<String, Object>> infoList = exportZbInfo(wmTaskparam);
        if (null != infoList && infoList.size() > 0) {
            excelMap.put("infoList", infoList);
        }
        //区分全职兼职学术推广员模版
        excelMap.put("userType", wmScorePackage1.getTypeid());
//        excelMap.put("scoreId", wmScorePackage1.getScorePackageName());
        List<String> extIds = wmTask.getExtIds();
        List<WmScorePackage> wmScorePackages = wmScorePackageService.listByIds(extIds);
        String scoreIds = wmScorePackages.stream().map(WmScorePackage::getScorePackageName).collect(Collectors.joining(","));
        excelMap.put("scoreId", StrUtil.isBlank(scoreIds) ? wmScorePackage1.getScorePackageName() : scoreIds);

        if (ArrayUtil.isNotEmpty(wmScorePackage1.getDrugProducerList())) {
            List<String> drugList = wmDaDrugEntDrugtableService.listDrugByDrugEntName(wmScorePackage1.getDrugProducerList());
            excelMap.put("drugList", String.join(",", drugList));
        }

        File f = null;
        if (wmScorePackage1.getPackageType1().equals("1")) {//定额
            f = ExportReport.main_bulidTemplate1_guangshengtang(excelMap, 2, upmsConfig.getBasePath());
        } else {//定量
            f = ExportReport.main_bulidTemplate2(excelMap, 2, upmsConfig.getBasePath());
        }

        FileInputStream input = new FileInputStream(f);

        String fileNamePrefix = "";
        if (StrUtil.equals(wmScorePackage1.getTypeid(), "3")) {
            fileNamePrefix = "全职学术信息沟通专员业绩报告";
        } else if (StrUtil.equals(wmScorePackage1.getTypeid(), "5")) {
            fileNamePrefix = "招商经理业绩报告";
        } else if (StrUtil.equals(wmScorePackage1.getTypeid(), "4")) {
            fileNamePrefix = "兼职学术信息沟通专员业绩报告";
        }

        MultipartFile multipartFile = new MockMultipartFile(fileNamePrefix + "(" + packageId + ")", "兼职学术推广员业绩报告(" + packageId + ").doc", "text/plain", IOUtils
                .toByteArray(input));
        return sysFileService.uploadFileAllUrlRealName(multipartFile, username);

    }

    /**
     * 合并导出--汇总，表格数据封装
     *
     * @param wmTask
     * @return
     */
    private Map<String, Object> exportZbCommonForGuangshengtang(WmTask wmTask) {
        String packageId = wmTask.getScorePackageId();  // 获取积分包ID
        if (null == packageId) {
            packageId = wmTask.getScorePackageDrugId();
        }

        Map<String, Object> excelMap = new HashMap<>();
        WmScorePackage wmScorePackage1 = wmScorePackageService.getById(packageId);
        WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getById(wmScorePackage1.getDrugEntId());
        if (wmDaDrugEnt == null) {
            wmDaDrugEnt = new WmDaDrugEnt();
            wmDaDrugEnt.setEntname("无");
        }

        List<String> strs = new ArrayList<>();
        if (packageId.contains(",")) {
            strs.addAll(Arrays.asList(packageId.split(",")));
        } else {
            strs.add(packageId);
        }
        wmTask.setExtIds(strs);


        List<Map<String, Object>> wmTaskList = wmTaskService.getTaskListByIdsOld(wmTask);
        if (wmScorePackage1.getPackageType2().equals("2")) {
            wmTaskList = wmTaskService.getTaskListByIdsJs(wmTask);
        }
        if (wmTaskList.size() > 0) {
            List<XlsTask> xlsTaskList = new ArrayList<>();
            Map<String, Object> userMap = new HashMap<>();
            for (Map<String, Object> wmt : wmTaskList) {
                XlsTask xlsTask = new XlsTask();
                xlsTask.setTaskNum(Integer.valueOf(wmt.get("score_count") + ""));
                xlsTask.setTaskType(wmt.get("base_id") + "");
                xlsTask.setUsername(wmt.get("realname") + "");
                xlsTask.setScore(Integer.parseInt((wmt.get("score") == null ? "0" : wmt.get("score")) + ""));
                xlsTask.setDrugEntName(wmDaDrugEnt.getEntname());
                xlsTask.setDeptName(wmt.get("dept_name") + "");
                xlsTask.setCreateTime(wmt.get("create_time") + "");
                xlsTaskList.add(xlsTask);

                String buildKey = wmt.get("realname") + "_" + wmDaDrugEnt.getEntname() + "_" + wmt.get("dept_name") + "";
                if (userMap.containsKey(buildKey)) {
                    try {
                        userMap.put(buildKey, Integer.parseInt(wmt.get("score") == null ? "0" : wmt.get("score") + "") + Integer
                                .parseInt(userMap.get(buildKey) == null ? "0" : userMap.get(buildKey) + ""));
                        userMap.put(buildKey + "_total", Integer.parseInt(wmt.get("score_count") + "") + Integer.parseInt(userMap
                                .get(buildKey + "_total") + ""));

                    } catch (Exception ex) {
                    }
                } else {
                    userMap.put(buildKey, wmt.get("score"));
                    userMap.put(buildKey + "_total", Integer.parseInt(wmt.get("score_count") + ""));
                }
            }


            List<WmTask> wmTaskDetialList = wmTaskService.getTaskListByIdsReturnWmtaskInfo(wmTask);
            List<Map<String, Object>> wmTaskDetialMap = new ArrayList<>();

            List<String> listPackageIds = new ArrayList<>();

            if (wmTaskDetialList.size() > 0) {
                for (WmTask wmTask1 :
                        wmTaskDetialList) {
                    Map<String, Object> map = new HashMap<>();
                    WmTaskType wmTaskTypeTemp1 = wmTaskTypeService.getById(wmTask1.getTaskTypeId());
                    map.put("taskType", wmTaskTypeTemp1.getTaskTypeName());
                    DateTimeFormatter dtf2 = DateTimeFormatter.ofPattern("yyyy-MM-dd");
                    String strDate2 = dtf2.format(wmTask1.getCreateTime());
                    map.put("taskTime", strDate2);
                    if (wmScorePackage1.getPackageType2().equals("2")) {
                        map.put("taskUser", sysUserService.getByIdIgnore(wmTask1.getTaskUserId()).getRealname());
                    } else {
                        map.put("taskUser", sysUserService.getByIdIgnore(wmTask1.getTaskUserId()).getRealname());
                    }

                    map.put("taskTypeId", wmTask1.getTaskTypeId());
                    map.put("score", wmTask1.getScore());
                    map.put("taskNum", 1);
                    wmTaskDetialMap.add(map);

                    if (listPackageIds.size() == 0) {
                        listPackageIds.add(wmTask1.getScorePackageId());
                    } else {
                        boolean isInscore = true;
                        for (String str : listPackageIds) {
                            if (str.equals(wmTask1.getScorePackageId())) {
                                isInscore = false;
                            }
                        }

                        if (isInscore) {
                            listPackageIds.add(wmTask1.getScorePackageId());
                        }
                    }
                }
            }

            if (listPackageIds.size() > 0) {
                List<WmScorePackage> wmScorePackageList = wmScorePackageService.listByIds(listPackageIds);
                Integer totalScorePackage = 0;
                BigDecimal settleAmount = new BigDecimal("0");
                if (wmScorePackageList.size() > 0) {
                    for (WmScorePackage wmScorePackage : wmScorePackageList) {
                        totalScorePackage += wmScorePackage.getScore();
                        if (wmScorePackage.getSettleStatus() != null && wmScorePackage.getSettleStatus() == 1) {
                            settleAmount = settleAmount.add(wmScorePackage.getSettleAmount());
                        }
                    }
                }
                excelMap.put("settleAmount", "0".equals(settleAmount.toString()) ? " " : settleAmount);
                excelMap.put("totalscorePackageScore", totalScorePackage);
                if (wmScorePackage1.getPackageType1().equals("2") || wmScorePackage1.getPackageType1().equals("3")) {
                    if (!wmScorePackage1.getPackageType2().equals("2")) {
                        excelMap.put("totalscorePackageTaskNum", wmScorePackage1.getTaskNum() * wmScorePackage1.getUserNum());//积分包值任务个数
                    }
                }

                List<WmTask> tasks = wmTaskService.list(Wrappers.<WmTask>lambdaQuery()
                        .in(WmTask::getScorePackageId, listPackageIds));

                if (CollUtil.isNotEmpty(tasks)) {
                    int sum = tasks.stream()
                            .filter(t -> "3".equals( t.getTaskStatus()) && WmTask.TaskSettleStatusEnum.SETTLED.getCode().equals(t.getTaskSettleStatus()))
                            .mapToInt(WmTask::getScore).sum();
                    excelMap.put("submitAmount", sum);
                }
            }

            excelMap.put("rwmxTable", wmTaskDetialMap);
            excelMap.put("mxTable", xlsTaskList);
            excelMap.put("ryTable", userMap);

            if (CollUtil.isNotEmpty(wmTaskDetialList)) {
                // 封装临床拜访汇总表数据
                List<Map<String, Object>> visitList = new ArrayList<>();
                // 查询医院拜访任务类型
                List<String> visitTaskContIdList = wmTaskDetialList.stream()
                        .filter(task -> "5".equals(task.getTaskTypeId()))
                        .map(WmTask::getTaskContentId)
                        .collect(Collectors.toList());
                if (CollUtil.isNotEmpty(visitTaskContIdList)) {
                    // 查询任务详情
                    List<WmTaskContent> taskContentList = wmTaskContentService.listByIds(visitTaskContIdList);
                    if (CollUtil.isNotEmpty(taskContentList)) {
                        List<Integer> signIdList = taskContentList.stream()
                                .map(wmTaskContent -> Integer.valueOf(wmTaskContent.getTemp3()))
                                .collect(Collectors.toList());
                        // 查询打卡记录
                        List<WmUserSign> wmUserSignList = wmUserSignService.listUserSign(signIdList);
                        DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
                        wmUserSignList.forEach(wmUserSign -> {
                            Map<String, Object> visitMap = MapUtil.newHashMap(5);
                            visitMap.put("taskTime", dateTimeFormatter.format(wmUserSign.getSignDate()));
                            visitMap.put("entName", wmUserSign.getSignEntName());
                            WmUserSignDetail userSignDetail = wmUserSign.getUserSignDetail();
                            if (userSignDetail != null) {
                                visitMap.put("purpose", String.join(",", userSignDetail.getPurposeName()));
                                visitMap.put("result", userSignDetail.getResultName());
                                visitMap.put("remark", userSignDetail.getRemark());
                            }
                            visitList.add(visitMap);
                        });
                        // 推广周期
                        String startTaskTime = dateTimeFormatter.format(wmUserSignList.get(0).getSignDate());
                        String endTaskTime = dateTimeFormatter.format(wmUserSignList.get(wmUserSignList.size()-1).getSignDate());
                        excelMap.put("visitCycle", String.format("%s至%s", startTaskTime, endTaskTime));
                    }
                }
                excelMap.put("visitTable", visitList);
                excelMap.put("visitTotalCount", visitTaskContIdList.size());

                // 封装学术会议登记表数据
                List<Map<String, Object>> meetingList = new ArrayList<>();
                // 查询会议举办的任务类型1,2,3,4
                List<String> meetingTaskContIdList = wmTaskDetialList.stream()
                        .filter(task -> StrUtil.equalsAny(task.getTaskTypeId(), "1", "2", "3", "4"))
                        .map(WmTask::getTaskContentId)
                        .collect(Collectors.toList());
                if (CollUtil.isNotEmpty(meetingTaskContIdList)) {
                    // 查询任务详情
                    List<WmTaskContent> taskContentList = wmTaskContentService.listByIds(meetingTaskContIdList);
                    if (CollUtil.isNotEmpty(taskContentList)) {
                        taskContentList.forEach(wmTaskContent -> {
                            WmTaskType taskType = wmTaskTypeService.getById(wmTaskContent.getTemp3());
                            Map<String, Object> meetingMap = MapUtil.newHashMap(6);
                            meetingMap.put("taskTime", wmTaskContent.getTemp4().substring(0, 10));
                            meetingMap.put("taskDrugList", wmTaskContent.getTemp12());
                            meetingMap.put("meetingTitle", wmTaskContent.getTemp2());
                            meetingMap.put("meetingType", taskType.getTaskTypeName());
                            meetingMap.put("meetingSign", wmTaskContent.getTemp31());
                            meetingMap.put("meetingSummary", wmTaskContent.getTemp9());
                            meetingList.add(meetingMap);
                        });
                    }
                }
                excelMap.put("meetingTable", meetingList);
            }
        }


        Map<String, Timestamp> maxMaxTime = wmTaskService.getMaxCreateTime(wmTask);
        System.out.println(maxMaxTime);
        LocalDateTime MaxTime = maxMaxTime.get("MaxTime").toLocalDateTime();
        excelMap.put("year", MaxTime.getYear() + "");
        Integer month = MaxTime.getMonthValue();
        if (month < 10) {
            excelMap.put("month", "0" + MaxTime.getMonthValue() + "");
        } else {
            excelMap.put("month", MaxTime.getMonthValue() + "");
        }
        Integer day = MaxTime.getDayOfMonth();
        if (day < 10) {
            excelMap.put("day", "0" + MaxTime.getDayOfMonth() + "");
        } else {
            excelMap.put("day", MaxTime.getDayOfMonth() + "");
        }

        List<Map<String, Object>> wmTaskCount = wmTaskService.getTaskListByIdsCount(wmTask);
        if (wmTaskCount.size() > 0) {
            Integer total = 0;
            Integer sum = 0;
            for (Map<String, Object> map :
                    wmTaskCount) {
                if (null != map.get("taskCount")) {
                    total += Integer.parseInt(map.get("taskCount") + "");
                }

                if (null != map.get("taskSum")) {
                    sum += Integer.parseInt(map.get("taskSum") + "");
                }

            }
            Map<String, Object> totalMap = new HashMap<>();
            totalMap.put("taskTypeName", "合计");
            totalMap.put("taskCount", total);
            totalMap.put("taskSum", sum);
            wmTaskCount.add(totalMap);

            excelMap.put("totalSubmitScore", sum);
            excelMap.put("totalSubmitTaskNum", total);
            excelMap.put("ztTable", wmTaskCount);
        }


        SysDept paramDept = new SysDept();
        paramDept.setDeptId(Integer.valueOf(wmScorePackage1.getSendPackageDeptId()));
        SysDept wmDaAgent = sysDeptService.selectDeptById(paramDept);
        excelMap.put("wt_ent", wmDaAgent.getName());

        excelMap.put("drugEnt", "");


        List<Map<String, Object>> wmTaskZd = wmTaskService.getTaskListByIdsZd(wmTask);
        if (wmScorePackage1.getPackageType2().equals("2")) {
            wmTaskZd = wmTaskService.getTaskListByIdsZdJs(wmTask);
        }
        String minDateStr = null;
        String maxDateStr = null;
        if (null != wmTaskZd) {
            if (wmTaskZd.size() > 0) {
                Map<String, Object> stringMap = wmTaskZd.get(0);
                if (null == stringMap) {
                    return null;
                }
                // 服务周期取 积分包领取审核通过时间~管理员审核积分包时最后审核通过的时间
                Map<String, String> serviceTimeRangeMap = wmScorePackageStatusService.getServiceTimeRange(wmScorePackage1);
                excelMap.put("service_date", serviceTimeRangeMap.get("service_start_date") + "至" + serviceTimeRangeMap.get("service_end_date"));
//                excelMap.put("service_date", stringMap.get("mindate") + "至" + stringMap.get("maxdate"));
                try {
                    minDateStr = serviceTimeRangeMap.get("service_start_date").substring(5, 7);
                    maxDateStr = serviceTimeRangeMap.get("service_end_date").substring(5, 7);

                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                excelMap.put("tMoney", stringMap.get("sumscore") + "");
                excelMap.put("report_users", stringMap.get("realname") + "");


                String ruleDate = wmScorePackage1.getBelongDate();

                excelMap.put("rule_year", ruleDate.substring(0, 4));

                String monthStr = ruleDate.substring(5, 7);
                if (null != minDateStr && null != maxDateStr) {
                    if (minDateStr.equals(maxDateStr)) {
                        monthStr = minDateStr;
                    } else {
                        // 跨年情况判断
                        if (!ruleDate.substring(0, 4).equals(serviceTimeRangeMap.get("service_end_date").substring(0, 4))) {
                            monthStr = String.format("%s月至%s年%s",
                                    minDateStr, serviceTimeRangeMap.get("service_end_date").substring(0, 4), maxDateStr);
                        } else {
                            // 跨年情况判断
                            if (!ruleDate.substring(0, 4).equals(serviceTimeRangeMap.get("service_end_date").substring(0, 4))) {
                                monthStr = String.format("%s月至%s年%s",
                                        minDateStr, serviceTimeRangeMap.get("service_end_date").substring(0, 4), maxDateStr);
                            } else {
                                monthStr = minDateStr + "月至" + maxDateStr;
                            }
                        }
                    }
                } else if (null != minDateStr) {
                    monthStr = minDateStr;
                } else if (null != maxDateStr) {
                    monthStr = maxDateStr;
                }

                excelMap.put("rule_month", monthStr);


            }
        }
        return excelMap;
    }

    /**
     * 个人报告导出--报告详情
     *
     * @param wmTask
     * @return
     * @throws IOException
     */
    public List<Map<String, Object>> exportZbInfo(WmTask wmTask) throws IOException {
        return reportExportService.exportZbInfo(wmTask);
    }

    public String getFieldValueByFieldName(String fieldName, Object object) {
        try {
            Field field = object.getClass().getDeclaredField(fieldName);
            //对private的属性的访问
            field.setAccessible(true);
            return field.get(object) + "";
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public R newExportNba(WmScorePackage wmScorePackage, Integer deptId, String username) throws IOException {
        return null;
    }

    @Override
    public R newExportNbaHistory(WmScorePackage wmScorePackage, Integer deptId, String username) throws IOException {
        return null;
    }

    @Override
    public R newExportNb(WmReport wmReport, Integer deptId, String username) throws IOException {
        return null;
    }
}
